package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_cfftp extends Object {

	public static void main(String args[]) {

    double beta;
    double a[][] = new double[3][301];

    Test_cfftp testcfftp = new Test_cfftp();
    beta=0.001-Math.PI;
    testcfftp.setfft(a,25,beta);
    FFT.cfftp(a,25);
    System.out.println("results produced by fast fourier " +
      "transform program:\n");
    testcfftp.out(a,25);
    testcfftp.fftans(a,25,beta);
    System.out.println("correct answers:\n");
    testcfftp.out(a,25);
    testcfftp.setfft(a,32,beta);
    FFT.cfft2p(a,5);
    FFT.orderf(a,5);
    System.out.println("results produced by fast fourier " +
      "transform program:\n");
    testcfftp.out(a,32);
    testcfftp.fftans(a,32,beta);
    System.out.println("correct answers:\n");
    testcfftp.out(a,32);
    testcfftp.setfft(a,16,beta);
    FFT.orderf(a,4);
    FFT.cfft2r(a,4);
    System.out.println("results produced by fast fourier " +
      "transform program:\n");
    testcfftp.out(a,16);
    testcfftp.fftans(a,16,beta);
    System.out.println("correct answers:\n");
    testcfftp.out(a,16);
  }


  public void setfft(double a[][], int n, double beta)
  {
    int k,i;
    double theta,tbeta;
    tbeta=2.0*beta;
    theta=-tbeta;
    for (i=1; i<=n; i++) {
      theta=theta+tbeta;
      a[1][i]=Math.cos(theta);
      a[2][i]=Math.sin(theta);
    }
  }


  public void fftans(double a[][], int n, double beta)
  {
    int k;
    double incr,pkdn,snbet,nm1bet,numarg,fact;
    
    incr=Math.PI/n;
    pkdn=-incr;
    snbet=Math.sin(n*beta);
    nm1bet=(n-1)*beta;
    for (k=1; k<=n; k++) {
      pkdn=pkdn+incr;
      numarg=nm1bet-pkdn;
      fact=snbet/Math.sin(beta+pkdn);
      a[1][k]=fact*Math.cos(numarg);
      a[2][k]=fact*Math.sin(numarg);
    }
  }


  public void out(double a[][], int n)
  {
    int i,j,k,p,rows;
    DecimalFormat fourDigit = new DecimalFormat("0.0000E0");
    rows=5;
    for (i=1; i<=2; i++) {
      j=0;
      for (p=1; p<=(n/rows); p++) {
        for (k=1; k<=rows; k++) {
          j++;
          System.out.print(fourDigit.format(a[i][j]) + "\t");
        }
        System.out.println();
      }
      for (p=1; p<=n-rows*(n/rows); p++) {
        j++;
        System.out.print(fourDigit.format(a[i][j]) + "\t");
      }
      if (n > rows*(n/rows))
        System.out.println();
      System.out.println();
    }   
  }

}
