package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_timspc extends Object {

	public static void main(String args[]) {

    int i,j;
    boolean cross;
    double meanx[] = new double[1];
    double varx[] = new double[1];
    double meany[] = new double[1];
    double vary[] = new double[1];
    double aucvx[] = new double[4];
    double aucvy[] = new double[4];
    double freq[] = new double[5];
    double powspx[] = new double[5];
    double powspy[] = new double[5];
    double croscv[] = new double[8];
    double recrsp[] = new double[5];
    double imcrsp[] = new double[5];
    double y[] = new double[5];
    double amcrsp[] = new double[5];
    double phcrsp[] = new double[5];
    double amtfxy[] = new double[5];
    double amtfyx[] = new double[5];
    double coher[] = new double[5];
    double x[] = new double[5];
    
    x[1]=1.1;   x[2]=1.3;    x[3]=1.2;    x[4]=1.2;
    y[1]=2.1;   y[2]=2.3;    y[3]=2.5;    y[4]=2.5;
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0"); 
    System.out.println("elements of first time series:");
    for (i=1; i<=4; i++)
      System.out.print("    " + x[i]);
    System.out.println("\n\nelements of second time series:");
    for (i=1; i<=4; i++)
      System.out.print("    " + y[i]);
    cross=false;
    while (true) {
      j=FFT.timspc(x,y,4,3,1.0,false,false,0.0,3,cross,meanx,varx,
                  meany,vary,aucvx,aucvy,freq,powspx,powspy,croscv,
                  recrsp,imcrsp,amcrsp,phcrsp,amtfxy,amtfyx,coher);
      if (cross) break;
      if ((j == 0) || (j == 7))
        cross=true;
      else {
        System.out.println("\npreliminary call of timspc " +
          "not satisfactorily executed");
        return;
      }
    }
    System.out.println("\n\nelements of first processed " +
      "time series x");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(x[i]));
    System.out.println("\n\nelements of second processed " +
      "time series y");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(y[i]));
    System.out.println("\n\nmean and variance of x\n   " +
      fiveDigit.format(meanx[0]) + "   " + fiveDigit.format(varx[0]) +
      "\n\nmean and variance of y\n   " +
      fiveDigit.format(meany[0]) + "   " + fiveDigit.format(vary[0]));
    System.out.println("\nautocovariances of x");
    for (i=1; i<=3; i++)
      System.out.print("   " + fiveDigit.format(aucvx[i]));
    System.out.println("\n\nautocovariances of y");
    for (i=1; i<=3; i++)
      System.out.print("   " + fiveDigit.format(aucvy[i]));
    System.out.println("\n\nfrequencies");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(freq[i]));
    System.out.println("\n\npower spectral estimates of x");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(powspx[i]));
    System.out.println("\n\npower spectral estimates of y");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(powspy[i]));
    System.out.println("\n\ncross covariances");
    for (i=1; i<=7; i++) {
      if (i == 5)
        System.out.println();
      System.out.print("   " + fiveDigit.format(croscv[i]));
    }
    System.out.println("\n\ncospectrum");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(recrsp[i]));
    System.out.println("\n\nquadrature spectrum");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(imcrsp[i]));
    System.out.println("\n\namplitudes of the cross spectrum");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(amcrsp[i]));
    System.out.println("\n\nphases of the cross spectrum");
    for (i=1; i<=4; i++)
      System.out.print("   " + fiveDigit.format(phcrsp[i]));
    if (j != 0) {
      if ((j-7)*(j-8) == 0) {
        System.out.println("\n\nNonpositive power spectral" +
          " estimate:\n  amplitudes of transfer functions" +
          " from x to y and y to x,\n  and the coherences " +
          "are all undefined");
        return;
      }
    }
    System.out.println("\n\namplitudes of transfer function " +
      "from x to y");
    for (i=1; i<=4; i++)
      System.out.print("   " + amtfxy[i]);
    System.out.println("\n\namplitudes of transfer function " +
      "from y to x");
    for (i=1; i<=4; i++)
      System.out.print("   " + amtfyx[i]);
    System.out.println("\n\nsquared coherences");
    for (i=1; i<=4; i++)
      System.out.print("   " + coher[i]);
  }
}
