package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_chldecsol2 extends Object {
	
	public static void main(String args[]) {

    int i,j;
    double determinant;
    double b[] = new double[5];
    double aux[] = new double[4];
    double pascal2[][] = new double[5][5];

    for (j=1; j<=4; j++) {
      pascal2[1][j]=1.0;
      for (i=2; i<=j; i++)
        pascal2[i][j] = (i == j) ?
            pascal2[i-1][j]*2.0 : pascal2[i][j-1]+pascal2[i-1][j];
      b[j]=Math.pow(2.0,j);
    }
    aux[2]=1.0e-11;
    Linear_algebra.chldecsol2(pascal2,4,aux,b);
    determinant=0.0;
    if (aux[3] == 4)
      determinant=Linear_algebra.chldeterm2(pascal2,4);
    else
      System.out.println("Matrix not positive definite");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Solution with CHLDECSOL2:\n  " + 
      fiveDigit.format(b[1]) + "  " + fiveDigit.format(b[2]) + "  " +
      fiveDigit.format(b[3]) + "  " + fiveDigit.format(b[4]));
    System.out.println("\nDeterminant with CHLDETERM2: " + determinant);
    for (j=1; j<=4; j++) {
      pascal2[1][j]=1.0;
      for (i=2; i<=j; i++)
        pascal2[i][j] = (i == j) ?
            pascal2[i-1][j]*2.0 : pascal2[i][j-1]+pascal2[i-1][j];
    }
    Linear_algebra.chldecinv2(pascal2,4,aux);
    System.out.println("\nInverse matrix with CHLDECINV2:");
    for (i=1; i<=4; i++) {
      for (j=1; j<=4; j++)
        if (j < i)
          System.out.print("\t");
        else
          System.out.print("\t" + pascal2[i][j]);
      System.out.print("\n");
    }
	}
}
