package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_arkmat extends Object
                         implements AP_arkmat_methods {

  static int tel;
  static double h1k,h2k,hpi,h1,h2;

	public static void main(String args[]) {

    int i,j,n,m,typ;
    int orde[] = new int[1];
    double te,cos1;
    double spr[] = new double[1];
    double t[] = new double[1];
    double u[][] = new double[21][11];
    
    Test_arkmat testarkmat = new Test_arkmat();
    hpi=0.5*Math.PI;
    h2=1.0/9.0;
    h1=(2.0*hpi)/9.0;
    n=m=10;
    h1k=h1*h1;
    h2k=h2*h2;
    tel=0;
    t[0]=0.0;
    te=1.0;
    for (j=1; j<=m; j++) u[n][j]=Math.sin(h1*(j-1));
    for (i=1; i<=n; i++) {
      cos1=Math.cos(h2*hpi*(i-1));
      for (j=1; j<=m; j++) u[i][j]=u[n][j]*cos1;
    }
    Basic.inimat(n+1,n+n,1,m,u,0.0);
    typ=3;
    orde[0]=2;
    spr[0]=80.0;
    System.out.println("The program delivers:\n\n    X    " +
      "  Y       U(1,X,Y)      U(1,X,Y)\n           " +
      "        COMPUTED      EXACT\n");
    Analytic_problems.arkmat(t,te,m,n+n,u,testarkmat,typ,orde,spr);
  }


  public void der(int m, int n, double t, double u[][], double du[][])
  {
    int i,j;

    n=n/2;
    for (i=2; i<=n-1; i++)
      for (j=2; j<=m-1; j++) {
        du[i][j]=u[i+n][j];
        du[i+n][j]=(u[i][j+1]-2.0*u[i][j]+u[i][j-1])/h1k+
                   (u[i+1][j]-2.0*u[i][j]+u[i-1][j])/h2k;
      }
    for (j=1; j<=m; j += m-1) {
      Basic.inimat(n+1,n+n,j,j,du,0.0);
      for (i=1; i<=n; i++) du[i][j]=u[n+1][j];
    }
    for (i=1; i<=n; i += n-1)
      for (j=2; j<=m-1; j++) {
        du[i][j]=u[i+n][j];
        if (i == 1)
          du[n+1][j]=(u[1][j+1]-2.0*u[1][j]+u[1][j-1])/h1k+
                     (2.0*u[2][j]-2.0*u[1][j])/h2k;
        else
          du[2*n][j]=0.0;
      }
  }


  public void out(double t[], double te, int m, int n,
                  double u[][], int type, int order[], double spr[])
  {
    int i;

    DecimalFormat threeDigit = new DecimalFormat("0.000");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000");
    tel++;
    if (t[0] == te) {
      for (i=1; i<=10; i++)
        System.out.println("  " + threeDigit.format((i-1)*h1) +
          "  " + threeDigit.format((i-1)*h2) + "    " +
          fiveDigit.format(u[i][i]) + "\t" + 
          fiveDigit.format(Math.sin(h1*(i-1))*
                           Math.cos(hpi*h2*(i-1))*
                           Math.cos(t[0]*Math.sqrt(1.0+hpi*hpi))));
      System.out.println("\nThe number of integration steps: " +
        tel + "\n Type is " + type + "   Order is " + order[0]);
    }
  }
}
