package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_diffsys extends Object
                          implements AP_diffsys_methods {

  static int passes,k;
 
	public static void main(String args[]) {

    int i;
    double xe,tol,h0;
    double y[] = new double[5];
    double s[] = new double[5];
    double x[] = new double[1];

    Test_diffsys testdiffsys = new Test_diffsys();
    System.out.println("Results with DIFFSYS are :\n" +
      "  K   DER.EV.    Y[1]        Y[3]");
    tol=1.0e-2;
    for (i=1; i<=5; i++) {
      tol *= 1.0e-2;
      passes=k=0;
      x[0]=0.0;
      xe=6.192169331396;
      y[1]=1.2;
      y[2]=y[3]=0.0;
      y[4] = -1.04935750983;
      s[1]=s[2]=s[3]=s[4]=0.0;
      h0=0.2;
      Analytic_problems.diffsys(x,xe,4,y,testdiffsys,tol,tol,s,h0);
    }
	}


  public void derivative(int n, double x, double y[], double dy[])
  {
    double mu,mu1,y1,y2,y3,y4,s1,s2;

    mu=1.0/82.45;
    mu1=1.0-mu;
    passes++;
    y1=y[1];
    y2=dy[1]=y[2];
    y3=y[3];
    y4=dy[3]=y[4];
    s1=(y1+mu)*(y1+mu)+y3*y3;
    s2=(y1-mu1)*(y1-mu1)+y3*y3;
    s1 *= Math.sqrt(s1);
    s2 *= Math.sqrt(s2);
    dy[2]=y1+2.0*y4-mu1*(y1+mu)/s1-mu*(y1-mu1)/s2;
    dy[4]=y3-2.0*y2-mu1*y3/s1-mu*y3/s2;
  }


  public void output(int n, double x[], double xe,
                     double y[], double s[])
  {
    k++;
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (x[0] >= xe)
      System.out.println("  " + k + "   " + passes +
      "   " + fiveDigit.format(y[1]) +
      "   " + fiveDigit.format(y[3]));
  }
}
