package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_eferk extends Object
                        implements AP_eferk_methods {

  static int passes,pasjac;
   
	public static void main(String args[]) {

  	int i;
  	int k[] = new int[1];
  	double xe,phi,tol;
  	double y[] = new double[3];
  	double j[][] = new double[3][3];
  	double x[] = new double[1];
  	double sigma[] = new double[1];
  	
  	Test_eferk testeferk = new Test_eferk();
  	System.out.println("The results with EFERK are:\n\n" +
  		" K     DER.EV.  JAC.EV.    Y[1]           Y[2]");
  	phi=4.0*Math.atan(1.0);
  	tol=1.0;
  	for (i=1; i<=4; i++) {
  		passes=pasjac=0;
  		x[0]=y[2]=0.0;
  		y[1]=1.0;
  		xe=50.0;
  		Analytic_problems.eferk(x,xe,2,y,sigma,phi,testeferk,j,k,
  		                        1,true,tol,tol,1.0e-6,50.0,false);
  		tol *= 1.0e-1;
  	}
	}


  public void derivative(int m, double y[])
  {
  	double y1,y2;

  	y1=y[1];
    y2=y[2];
  	y[1]=(y1+0.99)*(y2-1.0)+0.99;
  	y[2]=1000.0*((1.0+y1)*(1.0-y2)-1.0);
  	passes++;
  }


  public void jacobian(int m, double j[][], double y[],
                       double sigma[])
  {
  	j[1][1]=y[2]-1.0;
  	j[1][2]=0.99+y[1];
  	j[2][1]=1000.0*(1.0-y[2]);
  	j[2][2] = -1000.0*(1.0+y[1]);
  	sigma[0]=Math.abs(j[2][2]+j[1][1]-
  	         Math.sqrt((j[2][2]-j[1][1])*
					   (j[2][2]-j[1][1])+4.0*j[2][1]*j[1][2]))/2.0;
  	pasjac++;
  }


  public void output(double x[], double xe, int m, double y[],
                     double j[][], int k[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
  	if (x[0] == 50.0)
  		System.out.println(" " + k[0] + "\t" + passes + "\t" +
  		  pasjac + "\t" + fiveDigit.format(y[1]) + "\t" +
  		  fiveDigit.format(y[2]));
  }
}
