package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_efrk extends Object
                       implements AP_efrk_methods {

  static int passes;
   
	public static void main(String args[]) {

    int r,l,i,kk;
    int k[] = new int[1];
    double xe,step;
    double y[] = new double[3];
    double beta[] = new double[7];
    double x[] = new double[1];
    double sigma[] = new double[1];
    double phi[] = new double[1];
    double diameter[] = new double[1];

    Test_efrk testefrk = new Test_efrk();
    System.out.println("The results with EFRK are:\n\n" +
      "  R   L    K   DER.EV.     Y[1]         Y[2]");
    phi[0]=Math.PI;
    xe=0.0;
    beta[0]=beta[1]=1.0;
    for (r=1; r<=3; r++)
      for (l=1; l<=3; l++) {
        for (kk=2; kk<=r; kk++) beta[kk]=beta[kk-1]/kk;
        for (i=1; i<=2; i++) {
          step = ((i == 1) ? 1.0 : 0.1);
          passes=k[0]=0;
          x[0]=y[2]=0.0;
          y[1]=1.0;
          testefrk.output(1,2,x,xe,y,sigma,phi,
                          diameter, k,step,r,l);
          Analytic_problems.efrk(x,50.0,1,2,y,sigma,phi,
            diameter,testefrk,k,step,r,l,beta,r>=3,1.0e-3);
        }
        System.out.println();
      }
	}


  public void derivative(int m0, int m, double x, double y[])
  {
    double y1,y2;

    y1=y[1];
    y2=y[2];
    y[1]=(y1+0.99)*(y2-1.0)+0.99;
    y[2]=1000.0*((1.0+y1)*(1.0-y2)-1.0);
    passes++;
  }


  public void output(int m0, int m, double x[], double xe,
                     double y[], double sigma[], double phi[],
                     double diameter[], int k[], double step,
                     int r, int l)
  {
    double s;

    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    s=(-1000.0*y[1]-1001.0+y[2])/2.0;
    sigma[0]=Math.abs(s-Math.sqrt(s*s+10.0*(y[2]-1.0)));
    diameter[0]=2.0*step*Math.abs(1000.0*
                (1.99*y[2]-2.0*y[1]*(1.0-y[2])));
    if (x[0] == 50.0)
      System.out.println("  " + r + "   " + l + "   " + k[0] +
        "\t" + passes + "\t" + fiveDigit.format(y[1]) + "   " +
        fiveDigit.format(y[2]));
  }
}
