package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_efsirk extends Object
                         implements AP_efsirk_methods {

  static double lnx;
   
	public static void main(String args[]) {
 
    int n[] = new int[1];
    double xe;
    double x[] = new double[1];
    double delta[] = new double[1];
    double y[] = new double[3];
    double j[][] = new double[3][3];
    
    Test_efsirk testefsirk = new Test_efsirk();
    System.out.println("EFSIRK delivers:");
    xe=0.4;
    x[0]=0.01;
    y[1]=Math.log(0.01);
    y[2]=x[0];
    Analytic_problems.efsirk(x,xe,2,y,delta,testefsirk,j,n,
                             1.0e-2,1.0e-2,0.005,1.5,false);
    xe=8.0;
    x[0]=0.01;
    y[1]=Math.log(0.01);
    y[2]=x[0];
    Analytic_problems.efsirk(x,xe,2,y,delta,testefsirk,j,n,
                             1.0e-2,1.0e-2,0.005,1.5,false);
	}


  public void derivative(int m, double y[], double delta[])
  {
    double y2;

    y2=y[2];
    delta[0] = -Math.exp(y2);
    lnx=Math.log(y2);
    y[1]=(y[1]-lnx)*delta[0]+1.0/y2;
    y[2]=1.0;
  }


  public void jacobian(int m, double j[][], double y[],
                       double delta[])
  {
    double y2;

    y2=y[2];
    j[1][1]=delta[0];
    j[1][2]=(y[1]-lnx-1.0/y2)*delta[0]-1.0/(y2*y2);
    j[2][1]=j[2][2]=0.0;
  }


  public void output(double x[], double xe, int m, double y[],
                     double delta[], double j[][], int n[])
  {
    double y1;

    DecimalFormat oneDigit = new DecimalFormat("0.0E0");
    DecimalFormat twoDigit = new DecimalFormat("0.00");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000");
    if (x[0] == xe) {
      y1=y[1];
      lnx=Math.log(x[0]);
      System.out.println("\n N = " + n[0] + "    X = " +
        x[0] + "    Y(X) = " + fiveDigit.format(y1) +
        "   DELTA = " + twoDigit.format(delta[0]) +
        "\n ABS.ERR. = " + oneDigit.format(Math.abs(y1-lnx)) + 
        "    REL.ERR. = " +
        oneDigit.format(Math.abs((y1-lnx)/lnx)));
    }
  }
}
