package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_eft_2 extends Object implements AP_eft_methods {

  static double expt,lnt,u0,u1,u2,accuracy;
   
	public static void main(String args[]) {

    int j,l;
    int k[] = new int[1];
    double te,te1,te2;
    double u[] = new double[1];
    double t[] = new double[1];
    double eta[] = new double[1];
    double rho[] = new double[1];
    double hs[] = new double[1];

    Test_eft_2 testeft = new Test_eft_2();
    DecimalFormat oneDigit = new DecimalFormat("0.0E0");
    System.out.println("Results of EFT " +
      "with relaxed accuracy conditions for t > 3 :\n" +
      " K\tU(TE1)\t\tK\tU(TE2)\t\tRETA");
    te1=Math.exp(1.0);
    te2=Math.exp(2.0);
    accuracy=1.0;
    for (j=1; j<=4; j++) {
      accuracy *= 1.0e-1;
      t[0]=0.01;
      u[0]=Math.log(t[0]);
      k[0]=0;
      hs[0]=0.0;
      for (l=1; l<=2; l++) {
        te = (l == 1) ? te1 : te2;
        Analytic_problems.eft(t,te,0,0,u,testeft,Math.PI,k,
                              1.5,2,eta,rho,1.0e-4,hs);
      }
      System.out.println(oneDigit.format(accuracy));
    }
	}


  public void derivative(double t[], int m0, int m, int i, double u[])
  {
    if (i == 1) {
      expt=Math.exp(t[0]);
      lnt=Math.log(t[0]);
      u0=u[0];
      u1=u[0]=expt*(lnt-u0)+1.0/t[0];
    } else if (i == 2)
      u2=u[0]=expt*(lnt-u0-u1+1.0/t[0])-1.0/t[0]/t[0];
    else
      u[0]=expt*(lnt-u0-2.0*u1-u2+2.0/t[0]-1.0/t[0]/t[0])+
           2.0/t[0]/t[0]/t[0];
  }


  public double sigma(double t[], int m0, int m)
  {
    return Math.exp(t[0]);
  }


  public double diameter(double t[], int m0, int m)
  {
    return 2.0*Math.exp(2.0*t[0]/3.0);
  }


  public double aeta(double t[], int m0, int m)
  {
    return accuracy/10.0*((t[0] < 3.0) ? 1.0 :
           Math.exp(2.0*(t[0]-3.0)));
  }


  public double reta(double t[], int m0, int m)
  {
    return accuracy*((t[0] < 3.0) ? 1.0 :
           Math.exp(2.0*(t[0]-3.0)));
  }


  public void out(double t[], double te, int m0, int m, double u[],
      int k[], double eta[], double rho[])
  {
    DecimalFormat sixDigit = new DecimalFormat("0.000000E0");
    if (t[0] == te)
      System.out.print(k[0] + "\t" +
        sixDigit.format(u[0]) + "\t");
  }
}
