package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_gms extends Object
                      implements AP_gms_methods {
   
	public static void main(String args[]) {
  
    int n[] = new int[1];
    int jev[] = new int[1];
    int lu[] = new int[1];
    double x[] = new double[1];
    double y[] = new double[3];
    double delta[] = new double[1];

    Test_gms testgms = new Test_gms();
    System.out.println("The results with GMS are:\n");
    y[1]=y[2]=1.0;
    x[0]=0.0;
    delta[0]=0.0;
    Analytic_problems.gms(x,50.0,2,y,0.01,0.001,0.5,delta,
                      testgms,1.0e-5,1.0e-5,n,jev,lu,0,false);
	}


  public void derivative(int r, double y[], double delta[])
  {
    double y1,y2;

    y1=y[1];
    y2=y[2];
    y[1] = -1000.0*y1*(y1+y2-1.999987);
    y[2] = -2500.0*y2*(y1+y2-2.0);
  }


  public void jacobian(int r, double j[][], double y[],
                       double delta[])
  {
    double y1,y2;

    y1=y[1];
    y2=y[2];
    j[1][1] = 1999.987-1000.0*(2.0*y1+y2);
    j[1][2] = -1000.0*y1;
    j[2][1] = -2500.0*y2;
    j[2][2] = 2500.0*(2.0-y1-2.0*y2);
  }


  public void out(double x[], double xe, int r, double y[],
                  double delta[], int n[], int jev[], int lu[])
  {
    double ye1,ye2;

    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    if (x[0] == 50.0) {
      ye1=0.5976546988;
      ye2=1.4023434075;
      System.out.println(" X = " + (int)x[0] + 
        "    N = " + n[0] + "    JEV = " + jev[0] +
        "    LU = " + lu[0] + "\n\n Y1 = " + 
        fiveDigit.format(y[1]) + "     REL.ERR. = " + 
        twoDigit.format(Math.abs((y[1]-ye1)/ye1)) +
        "\n Y2 = " + fiveDigit.format(y[2]) + 
        "      REL.ERR. = " + 
        twoDigit.format(Math.abs((y[2]-ye2)/ye2)));
    }
  }
}
