package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_impex extends Object
                        implements AP_impex_methods {

  static int nfe,nje,point;
  static double print[] = new double[6];
   
	public static void main(String args[]) {

    boolean fail[] = new boolean[1];
    int n,i,it;
    double t,tend,eps,hmax,l,h2,n1,n2;
    double y[] = new double[4];
    double sw[] = new double[4];
    double f1[] = new double[4];
    double f2[] = new double[4];
    double z[] = new double[4];
    double x[] = new double[4];

    Test_impex testimpex = new Test_impex();
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("The results with IMPEX are:\n");
    n=3;
    nje=nfe=0;
    t=0.0;
    tend=400.0;
    eps=1.0e-5;
    hmax=400.0;
    y[1]=y[2]=y[3]=0.0;
    sw[1]=sw[2]=sw[3]=1.0;
    print[1]=0.1;  print[2]=1.0;  print[3]=10.0;
    print[4]=100.0; print[5]=400.0;
    Basic.dupvec(1,n,0,z,y);
    for (i=1; i<=n; i++)
      x[i] = (y[i] == 0.0) ? eps : (1.0+eps)*y[i];
    n1=Math.sqrt(Basic.vecvec(1,n,0,x,x))*eps;
    testimpex.deriv(t,x,f1,n);
    for (it=1; it<=5; it++) {
      testimpex.deriv(t,z,f2,n);
      Basic.elmvec(1,n,0,f2,f1,-1.0);
      n2=n1/Math.sqrt(Basic.vecvec(1,n,0,f2,f2));
      Basic.dupvec(1,n,0,z,x);
      Basic.elmvec(1,n,0,z,f2,n2);
    }
    testimpex.deriv(t,z,f2,n);
    Basic.elmvec(1,n,0,f2,f1,-1.0);
    l=Math.sqrt(Basic.vecvec(1,n,0,f2,f2))/n1;
    h2=Math.pow(eps*320.0,1.0/5.0)/(4.0*l);
    System.out.println("EPS = " + fiveDigit.format(eps) +
      "\nInterval of integration = (" + (int)t + "," +
      (int)tend + ")\nMaximally allowed stepsize = " +
      fiveDigit.format(hmax) + "\n\nLipschconst = " +
      fiveDigit.format(l) + "\nStarting stepsize = " +
      fiveDigit.format(h2) + "\nFunctional eval = " +
      nfe + "\n\n  X     ERROR     Y[1]            Y[2]" +
      "          NFE     NJE\n");
    Analytic_problems.impex(n,t,tend,y,testimpex,h2,
                            hmax,false,eps,sw,fail);
    System.out.println("\nNumber of functional evaluations = " +
      nfe + "\nNumber of Jacobian evaluations   = " + nje);
  }


  public void deriv(double t, double y[], double f1[], int n)
  {
    nfe++;
    f1[1]=0.2*(y[2]-y[1]);
    f1[2]=10.0*y[1]-(60.0-0.125*y[3])*y[2]+0.125*y[3];
    f1[3]=1.0;
  }


  public boolean available(double t, double y[], double a[][], int n)
  {
    nje++;
    a[1][1] = -0.2;
    a[1][2] = 0.2;
    a[1][3]=a[3][1]=a[3][2]=a[3][3]=0.0;
    a[2][1]=10.0;
    a[2][2]=0.125*y[3]-60.0;
    a[2][3]=0.125*(1.0+y[2]);
    return true;
  }


  public void update(double sw[], double r1[], int n)
  {
    int i;
    double s1,s2;

    for (i=1; i<=n; i++) {
      s1=1.0/sw[i];
      s2=Math.abs(r1[i]);
      if (s1 < s2) sw[i]=1.0/s2;
    }
  }


  public void control(double tp[], double t, double h,
                      double hnew, double y[][], double err[],
                      int n, double tend)
  {
    int i;
    double s,s2,s3,s4;
    double c[] = new double[6];
    double x[] = new double[n+1];
    
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    DecimalFormat oneDigit = new DecimalFormat("0.0E0");
    while (true) {
      s=(t-tp[0])/h;
      s2=s*s;
      s3=s2*s;
      s4=s3*s;
      c[3]=(s2-s)/2.0;
      c[4] = -s3/6.0+s2/2.0-s/3.0;
      c[5]=s4/24.0-s3/4.0+11.0*s2/24.0-s/4.0;
      for (i=1; i<=n; i++)
        x[i]=y[1][i]-s*y[2][i]+c[3]*y[3][i]+
             c[4]*y[4][i]+c[5]*y[5][i];
      System.out.println(" " + tp[0] + "\t" +
        oneDigit.format(err[3]) + "\t" +
        fiveDigit.format(x[1]) + "\t" +
        fiveDigit.format(x[2]) + "\t" +
        nfe + "\t" + nje);
      if (tp[0] >= tend) break;
      point++;
      tp[0] = print[point];
      if (tp[0] > t) break;
    }
  }
}
