package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_liniger1vs extends Object
                             implements AP_liniger1vs_methods {
   
	public static void main(String args[]) {

  	int i,itmax;
  	double reta;
  	double y[] = new double[3];
  	double info[] = new double[10];
  	double x[] = new double[1];
  	double sigma[] = new double[1];
  	double j[][] = new double[3][3];
  	
  	Test_liniger1vs testliniger1vs = new Test_liniger1vs();
  	System.out.println("The results with LINIGER1VS are:\n");
  	reta=1.0;
  	for (i=1; i<=3; i++) {
	  	reta *= 1.0e-2;
  		x[0]=y[2]=0.0;
	  	y[1]=1.0;
		  Analytic_problems.liniger1vs(x,50.0,2,y,sigma,testliniger1vs,
                                   j,10,0.1,50.0,reta,reta,info);
	  }
	  System.out.println();
  	reta = -1.0;
  	for (i=1; i<=3; i++) {
  		reta *= 1.0e-2;
  		x[0]=y[2]=0.0;
  		y[1]=1.0;
  		Analytic_problems.liniger1vs(x,50.0,2,y,sigma,testliniger1vs,
                                   j,10,0.1,1.0,reta,reta,info);
  	}
	}


  public void derivative(int m, double a[], double sigma[])
  {
  	double a1,a2;

  	a1=a[1];
  	a2=a[2];
  	a[1]=(a1+0.99)*(a2-1.0)+0.99;
	  a[2]=1000.0*((1.0+a1)*(1.0-a2)-1.0);
  }


  public void jacobian(int m, double j[][], double y[],
                       double sigma[])
  {
  	j[1][1]=y[2]-1.0;
  	j[1][2]=0.99+y[1];
	  j[2][1]=1000.0*(1.0-y[2]);
  	j[2][2] = -1000.0*(1.0+y[1]);
	  sigma[0]=Math.abs(j[2][2]+j[1][1]-
             Math.sqrt((j[2][2]-j[1][1])*
             (j[2][2]-j[1][1])+4.0*j[2][1]*j[1][2]))/2.0;
  }


  public void output(double x[], double xe, int m, double y[],
  			double sigma[], double j[][], double info[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    DecimalFormat oneDigit = new DecimalFormat("0.E0");
	  if (x[0] == 50.0)
	  	System.out.println(" " + (int)info[1] + "\t" +
        (int)info[2] + "\t" + (int)info[3] + "\t" +
        (int)info[4] + "\t" + (int)info[5] + "\t" + 
        (int)info[6] + "\t" + oneDigit.format(info[9]) +
        "\t" + fiveDigit.format(y[1])+ "\t" +
        fiveDigit.format(y[2]));
  }
}
