package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_liniger2_2 extends Object
                             implements AP_liniger2_methods {

  static int passes,pasjac;
   
	public static void main(String args[]) {

    int i,itmax;
    int k[] = new int[1];
    double step;
    double y[] = new double[3];
    double j[][] = new double[3][3];
    double x[] = new double[1];
    double sigma1[] = new double[1];
    double sigma2[] = new double[1];
    
    Test_liniger2_2 testliniger2 = new Test_liniger2_2();
    System.out.println("The results with LINIGER2 (third order)" +
      " are:\n K    DER.EV.  JAC.EV.     Y[1]            Y[2]");
    for (i=1; i<=2; i++) {
      step = (i == 1) ? 10.0 : 1.0;
      for (itmax=1; itmax<=3; itmax += 2) {
        passes=pasjac=0;
        x[0]=y[2]=0.0;
        y[1]=1.0;
        sigma2[0]=0.0;
        Analytic_problems.liniger2(x,50.0,2,y,sigma1,sigma2,
                 testliniger2,j,k,itmax,step,1.0e-4,1.0e-4);
      }
    }
	}


  public double f(int m, double y[], int i, double sigma1[],
                  double sigma2[])
  {
    if (i == 1)
      return (y[1]+0.99)*(y[2]-1.0)+0.99;
    else {
      passes++;
      return 1000.0*((1.0+y[1])*(1.0-y[2])-1.0);
    }
  }


  public void jacobian(int m, double j[][], double y[],
                       double sigma1[], double sigma2[])
  {
    j[1][1]=y[2]-1.0;
    j[1][2]=0.99+y[1];
    j[2][1]=1000.0*(1.0-y[2]);
    j[2][2] = -1000.0*(1.0+y[1]);
    sigma1[0]=Math.abs(j[2][2]+j[1][1]-
              Math.sqrt((j[2][2]-j[1][1])*
              (j[2][2]-j[1][1])+4.0*j[2][1]*j[1][2]))/2.0;
    pasjac++;
  }


  public boolean evaluate(int i)
  {
    return true;
  }


  public void output(double x[], double xe, int m,
                     double y[],double sigma1[],
                     double sigma2[], double j[][], int k[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (x[0] == 50.0)
      System.out.println(" " +
        k[0] + "\t" + passes + "\t" + pasjac + "\t" +
        fiveDigit.format(y[1]) + "\t" + 
        fiveDigit.format(y[2]));
  }
}
