package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_modifiedtaylor extends Object
                      implements AP_modifiedtaylor_methods {

  static double expt,lnt,c0,c1,c2,c3;
   
	public static void main(String args[]) {

    int j,order,accuracy;
    int k[] = new int[1];
    double te;
    double u[] = new double[1];
    double t[] = new double[1];
    double eta[] = new double[1];
    double rho[] = new double[1];
    double data[] =new double[5];
    double xtmp[] = new double[8];
    
    Test_modifiedtaylor testmodifiedtaylor = 
                             new Test_modifiedtaylor();
    System.out.println("The results with MODIFIEDTAYLOR are:");
    te=0.0;
    order=4;
    accuracy=3;
    data[0]=6.025;  data[1]=1.0; data[2]=0.5;  data[3]=1.0/6.0;
    data[4]=0.018455702;
    t[0]=u[0]=1.0e-2;
    k[0]=0;
    for (j=1; j<=2; j++) {
      te = (j == 1) ? Math.exp(1.0) : te*te;
      Analytic_problems.modifiedtaylor(t,te,0,0,u,
        testmodifiedtaylor,1.0e-4,k,order,accuracy,
        data,1.5,1,eta,rho,xtmp);
    }
	}


  public void derivative(double t[], int m0, int m, int i,
                         double a[])
  {
    if (i == 1) {
      expt=Math.exp(t[0]);
      lnt=Math.log(t[0]);
      c0=a[0];
      c1 = a[0] = -expt*c0+1.0/t[0]+expt*lnt;
    }
    if (i == 2) c2=a[0]=expt*(lnt+1.0/t[0]-c0-c1)-1.0/t[0]/t[0];
    if (i == 3)
      c3=a[0]=expt*(lnt+2.0/t[0]-c0-2.0*c1-c2-1.0/t[0]/t[0])+
              2.0/t[0]/t[0]/t[0];
    if (i == 4)
      a[0]=c3-2.0*(1.0+3.0/t[0])/t[0]/t[0]/t[0]+
           expt*((1.0-(2.0-2.0/t[0])/t[0])/t[0]-c1-c2*2.0-c3);
  }


  public double sigma(double t[], int m0, int m)
  {
    return Math.exp(t[0]);
  }


  public double aeta(double t[], int m0, int m)
  {
    return 1.0e-5;
  }


  public double reta(double t[], int m0, int m)
  {
    return 1.0e-4;
  }


  public void out(double t[], double te, int m0, int m,
                  double u[], int k[], double eta[], double rho[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (t[0] == te)
      System.out.println("\nNumber of steps: " + k[0] +
        "\nSolution:  T = " + fiveDigit.format(t[0]) +
        "    U(T) = " + fiveDigit.format(u[0]));
  }
}
