package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_multistep extends Object
                            implements AP_multistep_methods {
	
	public static void main(String args[]) {

    int i;
    double xend,hmin,eps;
    boolean first[] = new boolean[1];
    boolean btmp[] = new boolean[2];
    int itmp[] = new int[3];
    double xtmp[] = new double[7];
    double x[] = new double[1];
    double y[] = new double[13];
    double ymax[] = new double[3];
    double d[] = new double[53];
    double jac[][] = new double[3][3];
    
    Test_multistep testmultistep = new Test_multistep();
    hmin=1.0e-10;
    eps=1.0e-9;
    first[0]=true;
    x[0]=0.0;
    y[1]=y[2]=0.0;
    ymax[1]=0.0001;
    ymax[2]=1.0;
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Delivers with hmin = " +
      fiveDigit.format(hmin) + "  and eps = " +
      fiveDigit.format(eps));
    for (i=1; i<=10; i+=9) {
      xend=i;
      Analytic_problems.multistep(x,xend,y,hmin,5,ymax,eps,first,
                        d,testmultistep,jac,true,2,btmp,itmp,xtmp);
      System.out.println("   " + fiveDigit.format(y[1]) +
        "   " + fiveDigit.format(y[2]));
    }
	}


  public void deriv(double f[], int n, double x[], double y[])
  {
    double r;

    f[2]=r=3.0e7*y[1]*y[1];
    f[1]=0.04*(1-y[1]-y[2])-1.0e4*y[1]*y[2]-r;
  }


  public boolean available(int n, double x[], double y[],
                           double jac[][])
  {
    double r;

    jac[2][1]=r=6.0e7*y[1];
    jac[1][1] = -0.04-1.0e4*y[2]-r;
    jac[1][2] = -0.04-1.0e4*y[1];
    jac[2][2]=0.0;
    return true;
  }


  public void out(double h, int k, int n, double x[], double y[])
  {
    return;
  }
}
