package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_nonlinfemlagskew extends Object
                        implements AP_nonlinfemlagskew_methods {

  static int nc;

	public static void main(String args[]) {

    int n,i;
    double rho,d;
    double x[] = new double[51];
    double y[] = new double[51];
    double e[] = new double[7];

    Test_nonlinfemlagskew testnonlinfemlagskew = 
                          new Test_nonlinfemlagskew();
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    System.out.println("NONLINFEMLAGSKEW delivers:\n");
    for (nc=0; nc<=2; nc++)
      for (n=25; n<=50; n += 25) {
        e[2]=e[4]=1.0;
        e[1]=e[3]=e[5]=e[6]=0.0;
        for (i=0; i<=n; i++) {
          x[i]=(double)(i)/(double)(n);
          y[i]=0.0;
        }
        System.out.print(" N = " + n + "    NC = " + nc);
        Analytic_problems.nonlinfemlagskew(x,y,n,
                          testnonlinfemlagskew,nc,e);
        rho=0.0;
        for (i=0; i<=n; i++) {
          d=Math.abs(y[i]-1.0+x[i]*x[i]);
          if (rho < d) rho=d;
          }
        System.out.println("    MAX.ERROR = " +
          twoDigit.format(rho));
      }
  }


  public double f(double x, double y, double z)
  {
    return Math.exp(y)+Math.exp(z)-Math.exp(1.0-x*x)-
           Math.exp(-2.0*x)-2.0-2*nc;
  }


  public double fy(double x, double y, double z)
  {
    return Math.exp(y);
  }


  public double fz(double x, double y, double z)
  {
    return Math.exp(z);
  }
}
