package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_peide extends Object
                        implements AP_peide_methods {

	public static void main(String args[]) {

    int m,n,nobs;
    int bp[] = new int[4];
    int nbp[] = new int[1];
    double fa;
    double par[] = new double[7];
    double res[] = new double[27];
    double in[] = new double[7];
    double out[] = new double[8];
    double jtjinv[][] = new double[4][4];
    
    Test_peide testpeide = new Test_peide();
    System.out.println("        E S C E P - problem");
    m=3;  n=2;  nobs=23;  nbp[0]=3;
    par[1]=Math.log(1600.0);  par[2]=Math.log(0.8);
    par[3]=Math.log(1.2);
    in[0]=1.0e-14;  in[3]=in[4]=1.0e-4;  in[5]=50.0;
    in[6]=1.0e-2;   in[1]=1.0e-4;  in[2]=1.0e-5;
    bp[1]=17;  bp[2]=19;  bp[3]=21;
    fa=4.94;
    testpeide.communication(1,fa,n,m,nobs,nbp,par,res,bp,
                            jtjinv,in,out,0,0);
    Analytic_problems.peide(n,m,nobs,nbp,par,res,bp,jtjinv,
                            in,out,testpeide);
    testpeide.communication(2,fa,n,m,nobs,nbp,par,res,bp,
                            jtjinv,in,out,0,0);
  }


  public void communication(int post, double fa, int n, int m,
              int nobs, int nbp[], double par[], double res[],
              int bp[], double jtjinv[][], double in[], 
              double out[], int weight, int nis)
  {
    int i,j;
    double c;
    double conf[] = new double[m+1];
    
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    DecimalFormat threeDigit = new DecimalFormat("0.000E0");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (post == 5) {
      System.out.println("\nThe first residual vector\n  I" +
        "      RES[I]");
      for (i=1; i<=nobs; i++) 
        System.out.println(" " + i + "   " +
          fiveDigit.format(res[i]));
    } else if (post == 3) {
      System.out.println("\nThe Euclidean norm of the residual " +
        "vector : " +
        fiveDigit.format(Math.sqrt(Basic.vecvec(1,nobs,0,res,res))) +
        "\nCalculated parameters:\n");
      for (i=1; i<=m; i++)
        System.out.println("  " + fiveDigit.format(par[i]));
      System.out.println("Number of integration steps performed: " +
        nis);
    } else if (post == 4) {
      if (nbp[0] == 0)
        System.out.println("Minimization is started without" +
          " break-points");
      else {
        System.out.println("Minimization is started with weight =" +
          weight + "The extra parameters are the observations:");
        for (i=1; i<=nbp[0]; i++)
          System.out.println("  " + bp[i]);
      }
      System.out.println("Starting values of the parameters:");
      for (i=1; i<=m; i++)
        System.out.println("  \n" + fiveDigit.format(par[i]));
      System.out.println("Rel. tol. for the Eucl. norm of the " +
        "res. vector:" + fiveDigit.format(in[3]) +
        "\nAbs. tol. for the Eucl. norm of the res. vector:" +
        fiveDigit.format(in[4]) + "\nRelative starting value " +
        "of lambda: " + fiveDigit.format(in[6]));
    } else if (post == 1) {
      System.out.println("\nStarting values of the parameters:");
      for (i=1; i<=m; i++)
        System.out.println("  " + fiveDigit.format(par[i]));
      System.out.println("Numer of equations    : " + n +
        "\nNumber of observations: " + nobs +
        "\n\nMachine precision                         : " +
        twoDigit.format(in[0]) +
        "\nRelative local error bound for integration: " +
        twoDigit.format(in[2]) +
        "\nRelative tolerance for residual           : " +
        twoDigit.format(in[3]) +
        "\nAbsolute tolerance for residual           : " +
        twoDigit.format(in[4]) +
        "\nMaximum number of integrations to perform : " +
        (int)(in[5]) +
        "\nRelative starting value of lambda         : " +
        twoDigit.format(in[6]) +
        "\nRelative minimal steplength               : " +
        twoDigit.format(in[1]));
      if (nbp[0] == 0)
        System.out.println("There are no break-points\n");
      else {
        System.out.print("\nBreak-points are the observations:");
        for (i=1; i<=nbp[0]; i++)
          System.out.print("   " + bp[i]);
      }
      System.out.println("\nThe alpha-point of the " +
        "f-distribution: " + fa);
    } else if (post == 2) {
      if (out[1] == 0.0)
        System.out.println("\nNormal termination of the process\n");
      else if (out[1] == 1.0)
        System.out.println(
               "Number of integrations allowed was exceeded");
      else if (out[1] == 2.0)
        System.out.println(
               "Minimal steplength was decreased four times");
      else if (out[1] == 3.0)
        System.out.println("A call of deriv delivered false");
      else if (out[1] == 4.0)
        System.out.println("A call of jacdfdy delivered false");
      else if (out[1] == 5.0)
        System.out.println("A call of jacdfdp delivered false");
      else if (out[1] == 6.0)
        System.out.println("Precision asked for may not be attained");
      if (nbp[0] == 0)
        System.out.println("Last integration was performed " +
          "without break-points");
      else {
        System.out.println("The process stopped with Break-points:");
        for (i=1; i<=nbp[0]; i++) System.out.println("   " + bp[i]);
      }
      System.out.println("\nEucl. norm of the last residual " +
        "vector : " + fiveDigit.format(out[2]) +
        "\nEucl. norm of the first residual vector: " +
        fiveDigit.format(out[3]) +
        "\nNumber of integrations performed       : " +
        (int)(out[4]) +
        "\nLast improvement of the euclidean norm : " +
        fiveDigit.format(out[6]) +
        "\nCondition number of J'*J               : " +
        fiveDigit.format(out[7]) +
        "\nLocal error bound was exceeded (maxim.): " +
        out[5]);
      System.out.println("\n   Parameters   Confidence Interval");
      for (i=1; i<=m; i++) {
        conf[i]=Math.sqrt(m*fa*jtjinv[i][i]/(nobs-m))*out[2];
        System.out.println("   " + 
          fiveDigit.format(par[i]) + "\t" +
          fiveDigit.format(conf[i]));
      }
      c = (nobs == m) ? 0.0 : out[2]*out[2]/(nobs-m);
      System.out.println("\nCorrelation matrix          " +
        "Covariance matrix");
      for (i=1; i<=m; i++) {
        for (j=1; j<=m; j++) {
          if (i == j)
            System.out.print("                          ");
          if (i > j)
            System.out.print("  " + fiveDigit.format(
              jtjinv[i][j]/Math.sqrt(jtjinv[i][i]*jtjinv[j][j])));
          else
            System.out.print("  " +
              fiveDigit.format(jtjinv[i][j]*c));
        }
        System.out.println();
      }
      System.out.println("\nThe last residual vector\n\n  I" +
        "      RES[I]");
      for (i=1; i<=nobs; i++)
        System.out.println("  " + i + "\t" +
          threeDigit.format(res[i]));
    }
  }


  public boolean jacdfdp(int n, int m, double par[], double y[],
                         double x[], double fp[][])
  {
    double y2;

    y2=y[2];
    fp[1][1] = fp[1][3]=0.0;
    fp[1][2] = y2*Math.exp(par[2]);
    fp[2][1] = Math.exp(par[1])*(y[1]*(1.0-y2)-
               (Math.exp(par[2])+Math.exp(par[3]))*y2);
    fp[2][2] = -Math.exp(par[1]+par[2])*y2;
    fp[2][3] = -Math.exp(par[1]+par[3])*y2;
    return true;
  }


  public void data(int nobs, double tobs[], double obs[], int cobs[])
  {
    int i;
    double a[]={0.0002, 0.0004, 0.0006, 0.0008, 0.001,
        0.0012, 0.0014, 0.0016, 0.0018, 0.002, 0.02, 0.04, 0.06,
        0.08, 0.1, 1.0, 2.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0};
    double b[]={0.1648, 0.2753, 0.3493, 0.3990, 0.4322,
        0.4545, 0.4695, 0.4795, 0.4862, 0.4907, 0.4999, 0.4998,
        0.4998, 0.4998, 0.4998, 0.4986, 0.4973, 0.4936, 0.4872,
        0.4808, 0.4743, 0.4677, 0.4610};

    DecimalFormat fourDigit = new DecimalFormat("0.0000");
    tobs[0]=0.0;
    for (i=1; i<=nobs; i++) {
      tobs[i]=a[i-1];
      obs[i]=b[i-1];
      cobs[i]=2;
    }
    System.out.println("\nThe observations were:\n\n" +
      "  I     TOBS[I]       COBS[I]   OBS[I]");
    for (i=1; i<=nobs; i++)
      System.out.println("  " + i + "\t" + 
      fourDigit.format(tobs[i]) + "\t\t" + cobs[i] +
      "\t" + fourDigit.format(obs[i]));
  }


  public void callystart(int n, int m, double par[],
                         double y[], double ymax[])
  {
    y[1]=ymax[1]=ymax[2]=1.0;
    y[2]=0.0;
  }


  public boolean deriv(int n, int m, double par[], double y[],
                       double x[], double df[])
  {
    double y2;

    y2=y[2];
    df[1] = -(1.0-y2)*y[1]+Math.exp(par[2])*y2;
    df[2]=Math.exp(par[1])*((1.0-y2)*y[1]-(Math.exp(par[2])+
          Math.exp(par[3]))*y2);
    return true;
  }


  public boolean jacdfdy(int n, int m, double par[], double y[],
                         double x[], double fy[][])
  {
    fy[1][1] = -1.0+y[2];
    fy[1][2] = Math.exp(par[2])+y[1];
    fy[2][1] = Math.exp(par[1])*(1.0-y[2]);
    fy[2][2] = -Math.exp(par[1])*(Math.exp(par[2])+
                Math.exp(par[3])+y[1]);
    return true;
  }


  public void monitor(int post, int ncol, int nrow, double par[],
                      double res[], int weight, int nis[])
  {
  }
}
