package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_richardson extends Object
                             implements AP_richardson_methods {

  static double h,h2;

	public static void main(String args[]) {

    int j,l,lj,uj,ll,ul;
    int n[] = new int[1];
    int k[] = new int[1];
    double a,b;
    double discr[] = new double[3];
    double u[][] = new double[12][12];
    double rateconv[] = new double[1];
    double domeigval[] = new double[1];
    
    Test_richardson testrichardson = new Test_richardson();
    System.out.println("RICHARDSON delivers:\n");
    lj=0;  uj=11;  ll=0;  ul=11;  n[0]=50;
    a=0.163;  b=7.83;
    h=Math.PI/(uj-lj);
    h2=h*h;
    for (j=lj; j<=uj; j++)
      for (l=ll; l<=ul; l++)
        u[j][l] = (j==lj || j==uj || l==ll || l==ul) ?
                  (j*h)*(j*h)*(l*h)*(l*h) : 1.0;
    Analytic_problems.richardson(u,lj,uj,ll,ul,true,testrichardson,
                                 a,b,n,discr,k,rateconv,domeigval);
  }


  public void residual(int lj, int uj, int ll, int ul, double u[][])
  {
    int ujmin1,ulmin1,ljplus1,j,l;
    double u2;
    double u1[] = new double[12];

    ujmin1=uj-1;
    ulmin1=ul-1;
    ljplus1=lj+1;
    for (j=lj; j<=uj; j++) {
      u1[j]=u[j][ll];
      u[j][ll]=0.0;
    }
    for (l=ll+1; l<=ulmin1; l++) {
      u1[lj]=u[lj][l];
      u[lj][l]=0.0;
      for (j=ljplus1; j<=ujmin1; j++) {
        u2=u[j][l];
        u[j][l]=(4.0*u2-u1[j-1]-u1[j]-u[j+1][l]-u[j][l+1])+
                2.0*((j*h)*(j*h)+(l*h)*(l*h))*h2;
        u1[j]=u2;
      }
      u[uj][l]=0.0;
    }
    for (j=lj; j<=uj; j++) u[j][ul]=0.0;
  }


  public void out(double u[][], int lj, int uj, int ll, int ul,
                  int n[], double discr[], int k[],
                  double rateconv[], double domeigval[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (k[0] == n[0])
      System.out.println("  K    DISCR[1]     DISCR[2]     " +
        "RATECONV\n  " + k[0] + "   " +
        fiveDigit.format(discr[1]) + "   " +
        fiveDigit.format(discr[2]) + "   " +
        fiveDigit.format(rateconv[0]));
  }
}
